/** @file PCIDetection.h
 
   This file is taken from the Windows driver and adapted for Linux.
 
   @par CREATION  
   @author Krauth Julien
   @date   09.10.2006
   
   @par VERSION
   @verbatim
   $LastChangedRevision:$
   $LastChangedDate:$
   @endverbatim   
   
   @par LICENCE
   @verbatim
   Copyright (C) 2004,2005  ADDI-DATA GmbH for the source code of this module.
        
        ADDI-DATA GmbH 
        Dieselstrasse 3 
        D-77833 Ottersweier 
        Tel: +19(0)7223/9493-0 
        Fax: +49(0)7223/9493-92 
        http://www.addi-data-com 
        info@addi-data.com         
   @endverbatim   
 */
/*
  +-----------------------------------------------------------------------+
  | (C) ADDI-DATA GmbH          Dieselstrasse 3      D-77833 Ottersweier  |
  +-----------------------------------------------------------------------+
  | Tel : +49 (0) 7223/9493-0     | email    : info@addi-data.com         |
  | Fax : +49 (0) 7223/9493-92    | Internet : http://www.addi-data.com   |
  +-----------------------------------------------------------------------+
  | Project   : -                 | Compiler : BORLAND C                  |
  | Modulname : PCIDetection.H    | Version  : 3.1                        |
  +-------------------------------+---------------------------------------+
  | Author    : S.Weber           | Date     : 26.02.04                   |
  +-----------------------------------------------------------------------+
  | Description : PCI search and access header                            |
  +-----------------------------------------------------------------------+
  |                             UPDATE'S                                  |
  +-----------------------------------------------------------------------+
  |   Date   |   Author  |          Description of updates                |
  +----------+-----------+------------------------------------------------+
  |          |           |                                                |
  +-----------------------------------------------------------------------+
*/
#include "../../apci3701-private.h"

#ifndef PCI_DETECTION

	typedef struct {
	BYTE      b_AccessType;		// 1 I/O access. 0 Memory access
	UINT     ui_Address;		// Real address
	ULONG * pul_MemoryAddress;	// Memory mapped address
	}__attribute__ ((packed)) str_AddressInformation,*pstr_AddressInformation;

#define PCI_DETECTION
#endif // #ifndef PCI_DETECTION
